/* RCS $Id: j_expm.c,v 1.2 1997/07/15 14:57:04 ae13 Exp $ */
/*
$Log: j_expm.c,v $
 * Revision 1.2  1997/07/15  14:57:04  ae13
 * *** empty log message ***
 *
 * Revision 1.1  1997/05/16  13:26:20  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_intv j_expm(a_intv x)               */
/*                        a_intv x  ;                           */
/*                                                              */
/*      Arguments       : x = interval argument of exp(x)-1     */
/*                                                              */
/*      Description     : Fast interval exponential function - 1*/
/*                        for double IEEE Floating-Point        */
/*                        Arithmetic                            */
/*                                                              */
/*      Date            : 1996-03-08                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local a_intv j_expm(a_intv x)
#else
local a_intv j_expm(x)

a_intv x;
#endif
{
  a_intv res;
  if (x.INF==x.SUP)                     /* point interval */
    { 
       if (x.INF<0)
        {
          if (x.INF>-q_minr)
            {
               res.INF=x.INF;
               res.SUP=r_succ(x.INF);
            }
          else
            {
              res.INF=q_expm(x.INF);
              res.SUP=res.INF*q_exmm;
              res.INF*=q_exmp;
            } 
        }
       else 
         {
           if (x.INF<q_minr)
             {         
               res.INF=x.INF;
               if (x.INF==0)
                  res.SUP=0; 
               else
                  res.SUP=r_succ(x.INF);
             }
           else
             {
                res.INF=q_expm(x.INF);
                res.SUP=res.INF*q_exmp;
                res.INF*=q_exmm;
              }
        }
    }
  else
    {
      if (x.INF<=0)
        {
          if (x.INF>-q_minr)
            res.INF=x.INF;                 /* includes case x.INF=0 */
          else
            res.INF=q_expm(x.INF)*q_exmp;          
        }
      else  /* x.INF>0 */
        {
          if (x.INF<q_minr)
            res.INF=x.INF;      
          else 
            res.INF=q_expm(x.INF)*q_exmm;
        }
      if (x.SUP<0)
        {
          if (x.SUP>-q_minr)
            res.SUP=r_succ(x.SUP);
          else
            res.SUP=q_expm(x.SUP)*q_exmm;          
        }
      else  /* x.SUP>=0 */
        {
          if (x.SUP<q_minr)
            res.SUP=r_succ(x.SUP);        
          else 
            res.SUP=q_expm(x.SUP)*q_exmp;
        }
    }   

  if (res.INF<-1.0) res.INF=-1.0;
  return(res);
}
